//
// aObj : {view: "teqName", src: ["src_1","src_2",...] }
//

var OverlayDelay = 1000 // 1 second

var COverLayManager = function(aSrcObj){
	const lFrameNamePostfix = "_overlay_";
	const lObjIdPrefix = "sc_obj_";
	const lViewFrameId = "SC_View_001_embedSVG";
	const lIframeTagName = "iframe";
    var   lSrcObjLst = {};
	var   that = this;
	var   isDefined = that.isDefined;
	var   Delay = 1000 // 1 second


	var Init = function(aSrcObj){
		if(isDefined(aSrcObj,"object")){
				Add(aSrcObj);
		}
	};


	var Add = this.Add = function(aSrcObj){
		if(isDefined(aSrcObj,"object") && isDefined(aSrcObj.view,"string")){
			lSrcObjLst[aSrcObj.view]=Object.assign(aSrcObj);
			return true;
		}
		return false;
	};


	Init(aSrcObj);


	var AttachAttributes = function(aTag,aAttrObj){
		if(!isDefined(aTag))
			return false;
		if(!isDefined(aAttrObj,"object"))
			return false;
		for(var property in aAttrObj){
			switch(true){
				case (property == "class"):		$(aTag).addClass(aAttrObj[property].toString());
												break;
				case (property == "on"):		for(var handler in aAttrObj[property]){
													if(!isDefined(aAttrObj[property][handler],"function"))
														continue;
													aTag.addEventListener(handler,aAttrObj[property][handler]);
												}
												break;
				default:						$(aTag).attr(property,aAttrObj[property].toString());
												break;
			}
		}
		return true;
	};


	var	CleanUp = function(){
		$(lIframeTagName).each(function(){
			if($(this).attr("id").indexOf(lFrameNamePostfix)>=0){
				this.remove();
			}
		});
		for(var aFrame in that.overLayList){
			delete(that.overLayList[aFrame]);
		}
	};


	var Inject = function(){
		var	lHelpTxt = "";
		var lViewName = "";
		var lIndex = 0;
		var	lTargetView = null;
		var lViewName = "";
		var	lTargetRect;
		var	lObjRef = null;
		var lBbRect = null;
		var lViewFrameObj = null;
		var lAttrArr = null;

		// Which view is this?
		if(!isDefined(lTargetView = $("#"+lViewFrameId).get(0)))
			return false;
		lViewName = $(lTargetView).attr("src");
		if(!isDefined(lViewName,"string"))
			return false;
		if(!isDefined(lViewName = lViewName.slice(0,lViewName.indexOf("_teq"))))
			return false;
		lHelpTxt = lViewName + lFrameNamePostfix;

		// Do we need to inject in this view?
		if( !isDefined(lSrcObjLst,"object") ||
				!isDefined(lSrcObjLst[lViewName],"object") ||
		    !isDefined(lSrcObjLst[lViewName].view,"string") ||
				!isDefined(lSrcObjLst[lViewName].attr,"object") )
 		  return false;

		lAttrArr = Object.assign(lSrcObjLst[lViewName].attr);
		for(lIndex = 0; lIndex < lSrcObjLst[lViewName]["attr"].length; lIndex++){
			lFrameName = lHelpTxt + lIndex.toString();

			if( !isDefined(lObjRef =$("#" + lFrameName).get(0))){
				if( !isDefined(lObjRef = window.document.createElement("iframe")) )
					return false;
			}
			if( !isDefined(lTargetRect = $("#SC_View_001_embedSVG").contents().find("#" + lViewName + " #" + lObjIdPrefix + lIndex.toString() + " rect").get(0)) ){
					return false;
			}
			lBbRect = lTargetRect.getBoundingClientRect();
			that.overLayList[lFrameName] = lObjRef;
			$(lObjRef).attr("id",lFrameName)
				   .css("width", lBbRect.width.toString())
				   .css("height", lBbRect.height.toString())
				   .css("position","absolute")
				   .attr("scrolling","no")
				   .css("left",lBbRect.left.toString() + "px")
				   .css("top",lBbRect.top.toString() + "px")
					 .addClass("overlay");
			AttachAttributes(lObjRef,lAttrArr[lIndex]);
			$("body").append(lObjRef);
 	 	} // end for
		return true;
	}; // end Inject()


	var Resize = function(){
		var	lHelpTxt = "";
		var lViewName = "";
		var lIndex = 0;
		var lTargetView = null;
		var lViewName = "";
		var	lTargetRect;
		var	lObjRef = null;
		var lBbRect = null;
		var lViewFrameObj = null;
		var lAttrArr = null;

		// Which view is this?
		if(!isDefined(lTargetView = $("#"+lViewFrameId).get(0)))
			return false;
		lViewName = $(lTargetView).attr("src");
		if(!isDefined(lViewName,"string"))
			return false;
		if(!isDefined(lViewName = lViewName.slice(0,lViewName.indexOf("_teq"))))
			return false;
		lHelpTxt = lViewName + lFrameNamePostfix;

		// Do we need to inject in this view?
		if( !isDefined(lSrcObjLst,"object") ||
			!isDefined(lSrcObjLst[lViewName],"object") ||
			!isDefined(lSrcObjLst[lViewName].view,"string") ||
			!isDefined(lSrcObjLst[lViewName].attr,"object") ){
			return false;
 		}
		lAttrArr = Object.assign(lSrcObjLst[lViewName].attr);
		for(lIndex = 0; lIndex < lSrcObjLst[lViewName]["attr"].length; lIndex++){
			lFrameName = lHelpTxt + lIndex.toString();

			if( !isDefined(lObjRef =$("#" + lFrameName).get(0))){
					return false;
			}
			if( !isDefined(lTargetRect = $("#SC_View_001_embedSVG").contents().find("#" + lViewName + " #" + lObjIdPrefix + lIndex.toString() + " rect").get(0)) ){
					return false;
			}
			lBbRect = lTargetRect.getBoundingClientRect();
			that.overLayList[lFrameName] = lObjRef;
			$(lObjRef).css("width", lBbRect.width.toString())
					      .css("height", lBbRect.height.toString())
					      .css("left",lBbRect.left.toString() + "px")
					      .css("top",lBbRect.top.toString() + "px");
		} // end for
		return true;
	}; // end Resize()


	this.doInjectOverLay = function(){
		CleanUp();
		Inject();
	};

	this.doResizeOverLay = function(){
		Resize();
	};

	this.sendNewPosition = function(aLat,aLon){
		var lNewPositionEvent = new CustomEvent("newPosition",{detail: {lat: aLat, lon: aLon}});
		for(var lFrame in that.overLayList){
			that.overLayList[lFrame].dispatchEvent(lNewPositionEvent);
		}
	};


}; //end COverLayManager

COverLayManager.isDefined = COverLayManager.prototype.isDefined = function(aArg,aType){
	if((typeof aArg === "undefined") || (aArg == undefined) || (aArg == null)){
		return false;
	} else if ( ((typeof aType === "string") && (typeof aArg === aType)) ||
				((typeof aType === "undefined") || (aType == undefined) || (aType == null)) ) {
		return true;
	} else {
		return false;
	}
};


COverLayManager.prototype.overLayList = {};


var newPosHandler = function(aEvent){
	var lContWin = this.contentWindow;

	if(COverLayManager.isDefined(lContWin.mapPlayer,"object"))
		lContWin.mapPlayer.Set(aEvent.detail.lat,aEvent.detail.lon);
};


var createOverlayManager = function(){
	if(typeof overLayManager !== "undefined")
		return;
	overLayManager = new COverLayManager();
    overLayManager.Add({view: "MapExample1", attr: [ { src:"/OSM_JS/osm.html",
	                                                   class: "map",
	                                                   on:{ newPosition: newPosHandler }
												      }
												   ]});
    overLayManager.Add({view: "MapExample2", attr: [ { src:"/OSM_JS/osm.html",
	                                                  class: "map",
	                                                  on:{ newPosition: newPosHandler }
													},
													{ src:"https://webtv.feratel.com/webtv/?design=v3&cam=4181&c2=0",
													  class: "video"
													}
											      ]});
};


var publishOverlayManager = function(){
	if(typeof overLayManager !== "undefined"){
		$(".SCViews iframe").each(function(index, element){
								element.contentWindow.overLayManager = overLayManager;
		                   });
	}
};


window.addEventListener("load", function(){
	createOverlayManager();
	publishOverlayManager();
	setTimeout(overLayManager.doInjectOverLay,OverlayDelay);
});


window.addEventListener("resize",function(){
	setTimeout(overLayManager.doResizeOverLay,OverlayDelay/4);
});


//setTimeout(function(){overLayManager.sendNewPosition(47.531878,7.631896);},3*OverlayDelay);
